// gentunnel.cpp: dfinit le point d'entre pour l'application console.
//

#include "stdafx.h"
#include <stdlib.h>
#include <math.h>

#define PAL_ADD 32

#define SCW 320
#define SCH (256+PAL_ADD)
#define HW (SCW/2)
#define HH ((SCH-56)/2)  // - 0
#define CX (HW-1)
#define CY (HH-1-32+56)	// +0

#define BORDER_W	32

#define M_PI 3.141592653589793
#define M_2_PI (3.141592653589793*2.0)

#if (PAL_ADD == 0)
#define DIAMETER 4550.0
#define DIST_ADJ	10.0
#define DSHIFT		0.0
#else
#define DIAMETER 5000.0
#define DIST_ADJ	12.0
#define DSHIFT		-1.0
#endif 

#pragma warning(disable:4996)

void SwapWord(unsigned short & word);
void SwapLong(unsigned long & lword);
unsigned short SwapWord(unsigned short word);
unsigned long SwapLong(unsigned long lword);

int _tmain(int argc, _TCHAR* argv[])
{
	char* ptr = "toto\n";
	printf(ptr);
	unsigned short lut[(SCW-(BORDER_W*2))*SCH];
	unsigned short lutleft[(BORDER_W>>1)*SCH];
	unsigned short lutright[(BORDER_W>>1)*SCH];
		
	// Compute central LUT
	for(int j = 0; j < SCH; j++)
	{
		for(int i = BORDER_W, countx = 0; i < (SCW-BORDER_W); i++, countx++)
		{
			double angle;
			double x = static_cast<double>(i-CX);
			double y = -static_cast<double>(j-CY);
			if(y>=0.0)
				angle = atan2(y, x);
			else
				angle = atan2(-y, -x)+M_PI;

			double la = (angle*256.0)/M_2_PI;
			int ila = static_cast<int>(floor(la));
			ila = (ila-64-17) & 0xFF;

			double dist = sqrt(x*x+y*y);
			double ldist = -DSHIFT+DIAMETER/(dist+DIST_ADJ);
			int idist = static_cast<int>(ldist) & 0xFF;
			lut[countx+j*(SCW-(BORDER_W*2))] = SwapWord(ila + (idist<<8));
		}
	}
#if (PAL_ADD == 0)
	FILE* file = fopen("D:\\cpluscplus\\jaguar\\jaguar\\projects\\tube\\data\\lut.dat", "wb");
	printf("NTSC lut\n");
#else
	FILE* file = fopen("D:\\cpluscplus\\jaguar\\jaguar\\projects\\tube\\data\\lutpal.dat", "wb");
	printf("PAL lut\n");
#endif
	if(file != NULL)
	{		
		fwrite(&lut, (SCW-(BORDER_W*2))*SCH*2, 1, file);
		fclose(file);
	}

	// Compute left border
	for(int j = 0; j < SCH; j++)
	{
		for(int i = 0; i < BORDER_W; i+=2)	// i: double pixel
		{
			double angle;
			double x = static_cast<double>(i-CX);
			double y = -static_cast<double>(j-CY);
			if(y>=0.0)
				angle = atan2(y, x);
			else
				angle = atan2(-y, -x)+M_PI;

			double la = (angle*256.0)/M_2_PI;
			int ila = static_cast<int>(floor(la));
			ila = (ila-64-17) & 0xFF;

			double dist = sqrt(x*x+y*y);
			double ldist = -DSHIFT+DIAMETER/(dist+DIST_ADJ);
			int idist = static_cast<int>(ldist) & 0xFF;
			lutleft[(i>>1)+j*(BORDER_W>>1)] = SwapWord(ila + (idist<<8)); // i: double pixel
		}
	}

#if (PAL_ADD == 0)
	file = fopen("D:\\cpluscplus\\jaguar\\jaguar\\projects\\tube\\data\\lutleft.dat", "wb");
	printf("NTSC left lut\n");
#else
	file = fopen("D:\\cpluscplus\\jaguar\\jaguar\\projects\\tube\\data\\lutleftpal.dat", "wb");
	printf("PAL left lut\n");
#endif
	if(file != NULL)
	{		
		fwrite(&lutleft, (BORDER_W>>1)*SCH*2, 1, file);
		fclose(file);
	}

	// Compute right border
	for(int j = 0; j < SCH; j++)
	{	
		for(int i = (SCW-BORDER_W), xcount = 0; i < SCW; i+=2, xcount++)	// i: double pixel
		{
			double angle;
			double x = static_cast<double>(i-CX);
			double y = -static_cast<double>(j-CY);
			if(y>=0.0)
				angle = atan2(y, x);
			else
				angle = atan2(-y, -x)+M_PI;

			double la = (angle*256.0)/M_2_PI;
			int ila = static_cast<int>(floor(la));
			ila = (ila-64-17) & 0xFF;

			double dist = sqrt(x*x+y*y);
			double ldist = -DSHIFT+DIAMETER/(dist+DIST_ADJ);
			int idist = static_cast<int>(ldist) & 0xFF;
			lutright[xcount+j*(BORDER_W>>1)] = SwapWord(ila + (idist<<8)); // i: double pixel
		}
	}

#if (PAL_ADD == 0)
	file = fopen("D:\\cpluscplus\\jaguar\\jaguar\\projects\\tube\\data\\lutright.dat", "wb");
	printf("NTSC right lut\n");
#else
	file = fopen("D:\\cpluscplus\\jaguar\\jaguar\\projects\\tube\\data\\lutrightpal.dat", "wb");
	printf("PAL right lut\n");
#endif
	if(file != NULL)
	{		
		fwrite(&lutright, (BORDER_W>>1)*SCH*2, 1, file);
		fclose(file);
	}
	return 0;
}

void SwapWord(unsigned short & word)
{
	word = ((word & 0xFF) << 8) | (word >> 8);
}

void SwapLong(unsigned long & lword)
{
	lword = ((lword & 0xFF) << 24) | ((lword & 0xFF00) << 8) | ((lword & 0xFF0000) >> 8) | ((lword & 0xFF000000) >> 24);
}

unsigned short SwapWord(unsigned short word)
{
	return ((word & 0xFF) << 8) | (word >> 8);
}

unsigned long SwapLong(unsigned long lword)
{
	return ((lword & 0xFF) << 24) | ((lword & 0xFF00) << 8) | ((lword & 0xFF0000) >> 8) | ((lword & 0xFF000000) >> 24);
}

